-----------------------------------------------------------------------------
-- |
-- Module      :  Main
-- Copyright   :  (c) D. Sabel, Goethe-University, Frankfurt a.M., Germany
-- License     :  BSD-style 
-- 
-- Maintainer  :  sabel <at> ki.cs.uni-frankfurt.de
--
--  
-- The Main-module of the LRSX Tool, mainly handles input and
-- output and some pretty printing.
--
-----------------------------------------------------------------------------
module Main where
import Data.List
import System.Environment
import Data.Maybe
import Data.Either
import System.Process
import Text.Read
import System.FilePath
import System.IO
-- import the stuff of the LRSX libraries
import LRSX.Diagrams.DiagramCalculation
import LRSX.Interface.Pretty
import LRSX.Language.Syntax
import LRSX.Unification.UnificationProblem
import qualified LRSX.Unification.Unification as UN
import qualified LRSX.Matching.Matching as MA
import LRSX.Language.Constraints
import LRSX.Interface.Parser
import LRSX.Interface.DocStrings
import LRSX.Interface.Lexer
import LRSX.Util.Util
import LRSX.Diagrams.Rules
import qualified LRSX.Diagrams.AbstractDiagrams.Types as ADT
import qualified LRSX.Diagrams.AbstractDiagrams as AD
import qualified Data.Map.Strict as Map
import LRSX.Interface.CommandLine
-- * The main function

-- | The main function
--   First get the arguments from the command line, the parse the arguments and then process the parsed options
main :: IO ()
main = do 
    -- get arguments from the command line
    args <- getArgs
    -- first parse arguments into options of type 'OptCommand', then process the options
    processOpts $ parseArgs args



